#ifndef AXN_PLUGIN_H
#define AXN_PLUGIN_H

#include <extdll.h> // always
#include <meta_api.h> // of course


#define AXN_VERSION "1.6.1"
	// NOTE: removed last space; dunno why was that (to hack directly a binary?)

#define HLMOD 0
#define CSTRIKE 1

#define MAX_PLAYERS 32
#define MAX_PLAYER_NAME 128
#define MAX_MODEL_NAME 16
#define MAX_TEAMS 8
#define MAX_TEAM_NAME 16

#define MSGBEGIN 0
#define MSGEND -1

#define MOVE_NORMAL 0 
	// normal move in the direction monster is facing
#define MOVE_STRAFE 1 
	// moves in direction specified, no matter which way monster is facing

// Hit Group standards...
#define HITGROUP_GENERIC  0
#define HITGROUP_HEAD     1
#define HITGROUP_CHEST    2
#define HITGROUP_STOMACH  3
#define HITGROUP_LEFTARM  4
#define HITGROUP_RIGHTARM 5
#define HITGROUP_LEFTLEG  6
#define HITGROUP_RIGHTLEG 7

// axn_tracer_flag flags...
#define FL_TRACER_PLAYER 1
#define FL_TRACER_HIDE_OWN 2
#define FL_TRACER_HIDE_SNIPER 4
#define FL_TRACER_HIDE_SILENCED 8
#define FL_TRACER_HLTV 16

#pragma warning(disable:4800)
#pragma warning(disable:4710) // function not inlined


struct CurWeapon_t
{
	int id;        // weapon id
	int clip;      // current ammo in clip
};

struct player_extra_info_t
{
	char address[64];    // ip address (with port?)
	float player_wait;   // global time till another gas impact
	float smkdmg;        // damage done to player (aggregated)
	float last_pvoice_time; // global time of last pant voice
	CurWeapon_t curweap; // active weapon data
};

extern meta_globals_t *gpMetaGlobals;   // metamod globals
extern gamedll_funcs_t *gpGamedllFuncs; // gameDLL function tables
extern mutil_funcs_t *gpMetaUtilFuncs;  // metamod utility functions
extern enginefuncs_t g_engfuncs;
extern int g_mod_type;

// all cvars are declared within dllapi.cpp
extern cvar_t *axn_version;

extern cvar_t *axn_showaddress;
extern cvar_t *axn_tracer;
extern cvar_t *axn_tracer_flags;
extern cvar_t *axn_starthealth;
extern cvar_t *axn_statustext;
extern cvar_t *axn_noheadshot;
extern cvar_t *axn_damageimpact;
extern cvar_t *axn_longjump;
extern cvar_t *axn_bunnyjump;
extern cvar_t *axn_jumpability;
extern cvar_t *axn_flashtime;

extern player_extra_info_t g_PlayerInfo[MAX_PLAYERS+1];
extern edict_t *listenserver_edict;

extern bool bSpawn;
extern int g_msg_dest;
extern int g_msg_index;
extern int g_msg_type;
extern int g_map_type;

void UTIL_StringToVector(float *pVector, const char *pString);
void Restore(edict_t *pEntity);
void UTIL_Speak(edict_t *pent, const char *pszSentence);

float SetTimer(float timeout);
bool check_cmd(edict_t *pEntity);

// new util functions...
//void UTIL_Pathname_Convert(char *pathname);
//void UTIL_TrimWhitespace(char *text);
//void UTIL_ReplaceWhitespace(char *text);
//////////////////////////////////////////////////////////////
edict_t *UTIL_FindEntityInSphere(edict_t *pentStart, const Vector &vecCenter, float flRadius);
edict_t *UTIL_FindEntityByString(edict_t *pentStart, const char *szKeyword, const char *szValue);
edict_t *UTIL_FindEntityByClassname(edict_t *pentStart, const char *szName);
edict_t *UTIL_FindEntityByTargetname(edict_t *pentStart, const char *szName);
extern unsigned short FixedUnsigned16(float value, float scale);
extern short FixedSigned16(float value, float scale);
void UTIL_HudMessage( edict_t *pEdict, const hudtextparms_t &textparms, const char *pMessage );
void UTIL_SayTextAll(const char *pText, edict_t *pEdict);
BOOL IsAlive(edict_t *pEdict); // sdk_util.cpp

//void UTIL_GetHostName(char *ip_address);

void GameDLLInit(void); // in dllapi.cpp
void GameDLLDetach(void); // in dllapi.cpp

#endif // AXN_PLUGIN_H
