#include "extdll.h"
#include <meta_api.h> // of course
#include "enginecallback.h"
#include "sdk_util.h"
#include "cbase.h"
#include "const.h"
#include "weaponinfo.h"
#include "progdefs.h"
#include "axn_plugin.h"
#include "scriplib.h"
#include "entity.h"

#include "usrmsg.h"


int num_entities;
int num_rements = 0;
char *rements[MAX_REMOVE_ENTITIES];
entity_t entities[MAX_MAP_ENTITIES];

/*
================
ParseEntity
================
*/
bool ParseEntity(void)
{
	epair_t *e;
	entity_t *mapent;
	if(!GetToken(true))
		return false;
	if(strcmp(token, "{"))
		return Error("ParseEntity: { not found");
	if(num_entities==MAX_MAP_ENTITIES)
		return Error("num_entities==MAX_MAP_ENTITIES");
	mapent=&entities[num_entities];
	num_entities++;
	for(;;)
	{
		if(!GetToken(true))
			return Error("ParseEntity: EOF without closing brace");
		if(!strcmp(token, "}"))
			break;
		e=ParseEpair();
		e->next=mapent->epairs;
		mapent->epairs=e;
	}
	return true;
}

void RemoveEntities()
{
	char filename[256];
	sprintf(filename,"maps/%s.rement",STRING(gpGlobals->mapname));
	int i;
	for(i=0;i<num_rements;i++)
	{
		if(rements[i]&&rements[i]!=NULL)free(rements[i]);
	}
	num_rements=0;
	int length;
	char *remdata=(char*)LOAD_FILE_FOR_ME(filename, &length);
	if(!remdata||length==0)
	{
		return;
	}
	ParseFromMemory(remdata, length);
	for(i=0;i<MAX_REMOVE_ENTITIES;i++)
	{
		if(!GetToken(true))
			break;
		rements[num_rements]=copystring(token);
		num_rements++;
	}
}

#ifndef __linux__
hudtextparms_t ent_tparms={
	0.0, 0.5, // x, y
	0, // effect
	255, 255, 255, 0, // r, g, b, a1
	0, 0, 0, 0, // r2, g2, b2, a2
	0, 0, 10, 10, // fadein, fadeout, hold, fxtime
	5 // channel
};

void EntityOrigin(int x,int y,int z)
{
	short model = MODEL_INDEX("models/office_gibs.mdl");
	
	MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, listenserver_edict->v.origin);
	WRITE_BYTE(TE_PROJECTILE);
		WRITE_COORD(x);
		WRITE_COORD(y);
		WRITE_COORD(z);
		WRITE_COORD(0);
		WRITE_COORD(0);
		WRITE_COORD(0);
		WRITE_SHORT(model);
		WRITE_BYTE(30);
		WRITE_BYTE((BYTE)ENTINDEX(listenserver_edict));
	MESSAGE_END();

	MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, listenserver_edict->v.origin);
		WRITE_BYTE(TE_SPARKS);
		WRITE_COORD(x);
		WRITE_COORD(y);
		WRITE_COORD(z);
	MESSAGE_END();
}

void EntityBox(Vector mins, Vector maxs, Vector origin)
{
	mins=mins+origin;
	maxs=maxs+origin;
	MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY, listenserver_edict->v.origin);
		WRITE_BYTE(TE_BOX);
		WRITE_COORD(mins.x);
		WRITE_COORD(mins.y);
		WRITE_COORD(mins.z);
		WRITE_COORD(maxs.x);
		WRITE_COORD(maxs.y);
		WRITE_COORD(maxs.z);
		WRITE_SHORT(300);
		WRITE_BYTE(10);
		WRITE_BYTE(255);
		WRITE_BYTE(10);
	MESSAGE_END();
}
/*
#define TE_BOX 31
// coord, coord, coord boxmins
// coord, coord, coord boxmaxs
// short life in 0.1 s
// 3 bytes r, g, b
*/
void ShowEntity(entity_t *ent)
{
	epair_t *e=ent->epairs;
	char msg[1024]="";
	while(e)
	{
		sprintf(msg,"%s%s %s\n",msg,e->key,e->value);
		e=e->next;
	}
	UTIL_HudMessage(listenserver_edict, ent_tparms, msg);
}
#endif

char *_strlwr(char *src)
{
	char *s;
	for(s=src; *s!='\0'; ++s)
	{
		if(isupper(*s))
			*s=tolower(*s);
	}
	return(src);
}

void Precache(entity_t *ent)
{
	epair_t *e;
	e=ent->epairs;
	while(e)
	{
		// ALERT(at_console,"%s %s\n", e->key,e->value);
		if(strcmp(e->key,"model")==0&&strncmp(e->value,"*",1)!=0)
		{
			PRECACHE_MODEL(e->value);
		}
		else if(strcmp(e->key,"message")==0)
		{
			char *msg=_strlwr(copystring(e->value));
			if(strstr(msg,".wav"))
			{
				PRECACHE_SOUND(e->value);
			}
			if(msg&&msg!=NULL)free(msg);
		}
		e=e->next;
	}
}
static char keyname[32];
static char value[32];
static char classname[32]; // buffer for sz strings
int AddEntity(entity_t *ent)
{
	edict_t *pent=NULL;
	epair_t *e;
	e = ent->epairs;
	KeyValueData pkvd;
	Vector origin,maxs,mins;
	bool bMaxs=false, bMins=false;
	
	while(e)
	{
		if(strcmp(e->key, "classname") == 0)
		{
			pkvd.szClassName = classname;
			strcpy(classname, e->value);
			if(strcmp(e->value,"worldspawn") == 0)
			{
				pent=INDEXENT(0);
				e = ent->epairs;
				while(e)
				{
					if(strcmp(e->key,"skyname") == 0)
					{
						CVAR_SET_STRING("sv_skyname", e->value);
						break;
					}
					e=e->next;
				}
				return 0;
			}
			else
			{
				pent=CREATE_NAMED_ENTITY(MAKE_STRING(e->value));
				if(FNullEnt(pent))
				{
					return -1;
				}
				break;
			}
		}
		e=e->next;
	}
	e=ent->epairs;
	while(e)
	{
		// ALERT(at_console,"%s %s\n", e->key,e->value);
		if(strcmp(e->key,"classname")==0)
		{
		}
		else
		{
			if(strcmp(e->key,"model")==0&&strncmp(e->value,"*",1)!=0)
			{
				if(!bSpawn)
					strcpy(e->value,"models/office_gibs.mdl");
			}
			else if(strcmp(e->key,"message")==0)
			{
				char *msg=_strlwr(copystring(e->value));
				if(strstr(msg,".wav"))
				{
					if(!bSpawn)
						strcpy(e->value,"fvox/bell.wav");
				}
				if(msg&&msg!=NULL)free(msg);
			}
			else if(strcmp(e->key,"origin") == 0)
			{
				UTIL_StringToVector(origin, e->value);
			}
			else if(strcmp(e->key,"maxs") == 0)
			{
				bMaxs=true;
				UTIL_StringToVector(maxs, e->value);
				e=e->next;
				continue;
			}
			else if(strcmp(e->key,"mins") == 0)
			{
				bMins=true;
				UTIL_StringToVector(mins, e->value);
				e=e->next;
				continue;
			}
		}
		pkvd.fHandled=false;
		pkvd.szKeyName=keyname;
		pkvd.szValue=value;
		strcpy(keyname,e->key);
		strcpy(value,e->value);
		(*gpGamedllFuncs->dllapi_table->pfnKeyValue)(pent,&pkvd);
		DispatchKeyValue(pent,&pkvd);
		e=e->next;
	}
	(*gpGamedllFuncs->dllapi_table->pfnSpawn)(pent);
	if(bMaxs&&bMins)SET_SIZE(pent, mins, maxs);
	return ENTINDEX(pent);
}

void LoadEntities()
{
	int i=0;
	char filename[256];
	sprintf(filename,"maps/%s.addent", STRING(gpGlobals->mapname));
	epair_t *e,*r;
	for(i=0;i<num_entities;i++)
	{
		entities[i].index=0;
		e=entities[i].epairs;
		while(e)
		{
			if(e->key&&e->key!=NULL)free(e->key);
			if(e->value&&e->value!=NULL)free(e->value);
			r=e;
			e=e->next;
			if(r&&r!=NULL)free(r);
		}
	}
	num_entities=0;
	memset(&entities,0,sizeof(entity_t)*MAX_MAP_ENTITIES);
	int length;
	char *entdata=(char*)LOAD_FILE_FOR_ME(filename, &length);
	if(!entdata||length==0)
	{
		return;
	}
	ParseFromMemory(entdata, length);
	while(ParseEntity())
	{
		//for test
		// entities[num_entities-1].index=AddEntity(&entities[num_entities-1]);
	}
}
