// From SDK dlls/h_export.cpp:

/***
*
*	Copyright (c) 1999, 2000 Valve LLC. All rights reserved.
*	
*	This product contains software technology licensed from Id 
*	Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc. 
*	All Rights Reserved.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/
/*

  ===== h_export.cpp ========================================================

	Entity classes exported by HalfLife.
	
*/

#include <extdll.h>
#include <h_export.h>
#include "axn_plugin.h"
// From SDK dlls/h_export.cpp:

//! Holds engine functionality callbacks
char *g_argv;
int g_mod_type;
enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;

#ifndef __linux__
HGLOBAL h_global_argv = NULL;
#else
char h_global_argv[1024];
#endif

#ifndef __linux__
//-----------------------------------------------------------------------------
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH)
	{
	}
	else if (fdwReason == DLL_PROCESS_DETACH)
	{		
		if (h_global_argv)
		{
			GlobalUnlock(h_global_argv);
			GlobalFree(h_global_argv);
		}
	}
	return TRUE;
}
#endif
//-----------------------------------------------------------------------------
// Receive engine function table from engine.
// This appears to be the _first_ DLL routine called by the engine, so we
// do some setup operations here.
void WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
{
	char gamedir[PATH_MAX];
#ifndef __linux__
	h_global_argv = GlobalAlloc(GMEM_SHARE, 1024);
	g_argv = (char *)GlobalLock(h_global_argv);
#else
	g_argv = (char *)h_global_argv;
#endif
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	
	gpGlobals = pGlobals;
	
	GET_GAME_DIR(gamedir);
	if(!strcmp(gamedir, "cstrike") || !strcmp(gamedir, "czero") || !strcmp(gamedir, "csv15"))
		g_mod_type = CSTRIKE;
	else
		g_mod_type = HLMOD;
}
//-----------------------------------------------------------------------------
