#ifndef ListH
#define ListH

#ifndef ListT
	#error Do not include this file directly! Use .cpp instead
#endif
//---------------------------------------------------------------------------
template <class T> struct SListItem
{
  T Data;
  SListItem *Next;
};
//---------------------------------------------------------------------------
template <class T> class CDataList
{
  int
    m_iCount;

protected:
  SListItem<T>
    *m_pHead, *m_pTail;

  SListItem<T>* NewItem(void);
  SListItem<T>* GetItem(int Index);
  void AppendItem(SListItem<T>*);
  void InsertItem(int Index, SListItem<T>*);
  void DeleteItem(SListItem<T>*, SListItem<T>*);
  void GetPare(int Index, SListItem<T>**, SListItem<T>**);
  void Error(const char *Msg, const char *Within, ...);

public:
  CDataList();
  ~CDataList() { Clear(); };

  T*   Add(void);
  bool Add(T&);
  T*   Insert(int);
  bool Insert(int, T&);
  T*   Get(int);
  T    Extract(int);
  void Delete(int);
  bool Remove(T&);
  bool Remove(T*);
  void Clear(void);
  int Count(void);
};
//---------------------------------------------------------------------------
#endif
