/***
*
*	Copyright (c) 1996-2001, Valve LLC. All rights reserved.
*	
*	This product contains software technology licensed from Id 
*	Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc. 
*	All Rights Reserved.
*
****/

// scriplib.h
#ifndef SCRIPLIB_H
#define SCRIPLIB_H

#include <string.h>
#include <stdio.h>
#include <malloc.h>

#define	MAXTOKEN	512

typedef struct epair_s
{
	struct epair_s	*next;
	char	*key;
	char	*value;
} epair_t;

// key / value pair sizes
#define	MAX_KEY		32
#define	MAX_VALUE	1024

extern char    token[MAXTOKEN];
extern int			num_entities;

void LoadScriptFile (char *filename);
void ParseFromMemory (char *buffer, int size);
epair_t *ParseEpair (void);
bool GetToken (bool crossline);
void UnGetToken (void);
bool TokenAvailable (void);

bool Error(char *error, ...);

char *copystring(char *s);

#endif